package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.MonDevFsHour;
import cn.cecep.talroad.service.IMonDevFsHourService;
import cn.cecep.talroad.vo.MonDevFsHourVo;
import cn.cecep.talroad.vo.query.MonDevFsHourQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 设备数据-垃圾焚烧-小时 保存设备的小时数据Controller 控制层
 *
 * @author szhpt
 * @date 2023-01-10*/
@Api(tags = "监测监控--工况数据--设备数据-垃圾焚烧-小时 保存设备的小时数据")
@RestController
@RequestMapping("/monDevFsHour")
public class MonDevFsHourController extends BasesController
{
    @Autowired
    private IMonDevFsHourService monDevFsHourService;

    /**
     * 查询设备数据-垃圾焚烧-小时 保存设备的小时数据列表
     */
    @ApiOperation(value = "查询设备数据-垃圾焚烧-小时 保存设备的小时数据")
    @GetMapping("/list")
    public AjaxResults<IPage<MonDevFsHour>> list(MonDevFsHourQuery monDevFsHour)
    {
        Page<MonDevFsHour> page = new Page<>(monDevFsHour.getPageNum(), monDevFsHour.getPageSize());
        IPage<MonDevFsHour> list = monDevFsHourService.page(page, MonDevFsHourQuery.createLambdaQueryWrapper(monDevFsHour));
        return AjaxResults.success(list);
    }
    

    /**
     * 导出设备数据-垃圾焚烧-小时 保存设备的小时数据列表
     */
    @ApiOperation(value = "导出设备数据-垃圾焚烧-小时 保存设备的小时数据")
    @Log(title = "设备数据-垃圾焚烧-小时 保存设备的小时数据", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, MonDevFsHour monDevFsHour)
    {
        List<MonDevFsHour> list = monDevFsHourService.selectMonDevFsHourList(monDevFsHour);
        ExcelUtil<MonDevFsHour> util = new ExcelUtil<MonDevFsHour>(MonDevFsHour.class);
        util.exportExcel(response, list, "设备数据-垃圾焚烧-小时 保存设备的小时数据数据");
    }

    /**
     * 获取设备数据-垃圾焚烧-小时 保存设备的小时数据详细信息
     */
    @ApiOperation(value = "获取设备数据-垃圾焚烧-小时 保存设备的小时数据详细信息")
    @PostMapping(value = "/{dataId}")
    public AjaxResults<MonDevFsHour> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(monDevFsHourService.getById(id));
    }
    /**
     * 新增设备数据-垃圾焚烧-小时 保存设备的小时数据
     */
    @ApiOperation(value = "新增设备数据-垃圾焚烧-小时 保存设备的小时数据")
    @Log(title = "设备数据-垃圾焚烧-小时 保存设备的小时数据", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody MonDevFsHour monDevFsHour) {
        return toAjax(monDevFsHourService.save(monDevFsHour));
    }
    /**
     * 修改设备数据-垃圾焚烧-小时 保存设备的小时数据
     */
    @ApiOperation(value = "修改设备数据-垃圾焚烧-小时 保存设备的小时数据")
    @Log(title = "设备数据-垃圾焚烧-小时 保存设备的小时数据", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody MonDevFsHourVo monDevFsHourVo) {
        if(ObjectUtil.isEmpty(monDevFsHourVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(monDevFsHourVo.getDataId())){
            throw new InvalidParameterException("参数id为空");
        }
        MonDevFsHour monDevFsHour = monDevFsHourService.getById(monDevFsHourVo.getDataId());
        if(ObjectUtil.isEmpty(monDevFsHour)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", monDevFsHourVo.getDataId()));
        }
        //赋值
        BeanUtil.copyProperties(monDevFsHourVo,monDevFsHour);
        return toAjax(monDevFsHourService.saveOrUpdate(monDevFsHour));
    }

    /**
     * 删除设备数据-垃圾焚烧-小时 保存设备的小时数据
     */
    @ApiOperation(value = "删除设备数据-垃圾焚烧-小时 保存设备的小时数据")
    @RequiresPermissions("talroad:hour:remove")
    @Log(title = "设备数据-垃圾焚烧-小时 保存设备的小时数据", businessType = BusinessType.DELETE)
    @PostMapping("/{dataIds}")
    public AjaxResults<Boolean> remove(@PathVariable Long[] dataIds) {
        return toAjax(monDevFsHourService.removeByIds(Arrays.asList(dataIds)));
    }
}
